Index: trunk/MagicSoft/Mars/datacenter/macros/fillstar.C
===================================================================
--- trunk/MagicSoft/Mars/datacenter/macros/fillstar.C	(revision 7703)
+++ trunk/MagicSoft/Mars/datacenter/macros/fillstar.C	(revision 7756)
@@ -214,9 +214,21 @@
     }
 
-    Double_t numstarmean = g ? TMath::Median(g->GetN(), g->GetY()) : -1;
-    TString numstarsmean = Form("%5.1f", numstarmean);
+    Double_t numstarmed = g ? TMath::Median(g->GetN(), g->GetY()) : -1;
+    TString numstarsmed = Form("%5.1f", numstarmed);
     Double_t numstarrms = g ? g->GetRMS(2) : -1;
     TString numstarsrms = Form("%5.1f", numstarrms);
 
+    g = (TGraph*)arr.FindObjectInCanvas("NumStarsCor", "TGraph", "MHPointing");
+    if (!g)
+    {
+        cout << "WARNING - Reading of NumStarsCor failed." << endl;
+//        return 2;
+    }
+
+    Double_t numcormed = g ? TMath::Median(g->GetN(), g->GetY()) : -1;
+    TString numcorsmed = Form("%5.1f", numcormed);
+    Double_t numcorrms = g ? g->GetRMS(2) : -1;
+    TString numcorsrms = Form("%5.1f", numcorrms);
+
     g = (TGraph*)arr.FindObjectInCanvas("Brightness", "TGraph", "MHPointing");
     if (!g)
@@ -226,6 +238,6 @@
     }
 
-    Double_t brightnessmean = g ? TMath::Median(g->GetN(), g->GetY()) : -1;
-    TString skybrightnessmean = Form("%5.1f", brightnessmean);
+    Double_t brightnessmed = g ? TMath::Median(g->GetN(), g->GetY()) : -1;
+    TString skybrightnessmed = Form("%5.1f", brightnessmed);
     Double_t brightnessrms = g ? g->GetRMS(2) : -1;
     TString skybrightnessrms = Form("%5.1f", brightnessrms);
@@ -252,6 +264,7 @@
     cout << "  Rate after ImgCl [Hz] " << datarate  << endl;
     cout << "  Maximum Humidity [%]  " << maxhum    << endl;
-    cout << "  Number of Stars       " << numstarsmean      << " +/- " << numstarsrms       << endl;
-    cout << "  Skybrightness         " << skybrightnessmean << " +/- " << skybrightnessrms  << endl;
+    cout << "  Number of Stars       " << numstarsmed      << " +/- " << numstarsrms       << endl;
+    cout << "  Number of cor. Stars  " << numcormed        << " +/- " << numcorrms         << endl;
+    cout << "  Skybrightness         " << skybrightnessmed << " +/- " << skybrightnessrms  << endl;
 
     TString query;
@@ -268,7 +281,9 @@
                      " fDataRate=%d, "
                      " fMaxHumidity=%s ,"
-                     " fNumStarsMean=%s ,"
+                     " fNumStarsMed=%s ,"
                      " fNumStarsRMS=%s ,"
-                     " fBrightnessMean=%s ,"
+                     " fNumStarsCorMed=%s ,"
+                     " fNumStarsCorRMS=%s ,"
+                     " fBrightnessMed=%s ,"
                      " fBrightnessRMS=%s ,"
                      " fInhomogeneity=%s ",
@@ -277,6 +292,7 @@
                      muonrate.Data(), PSF.Data(),
                      datarate, maxhum.Data(),
-                     numstarsmean.Data(), numstarsrms.Data(),
-                     skybrightnessmean.Data(), skybrightnessrms.Data(),
+                     numstarsmed.Data(), numstarsrms.Data(),
+                     numcorsmed.Data(), numcorsrms.Data(),
+                     skybrightnessmed.Data(), skybrightnessrms.Data(),
                      inhomogen.Data());
     }
@@ -292,6 +308,8 @@
                      " fDataRate=%d, "
                      " fMaxHumidity=%s, "
-                     " fNumStarsMean=%s ,"
+                     " fNumStarsMed=%s ,"
                      " fNumStarsRMS=%s ,"
+                     " fNumStarsCorMed=%s ,"
+                     " fNumStarsCorRMS=%s ,"
                      " fBrightnessMean=%s ,"
                      " fBrightnessRMS=%s ,"
@@ -302,6 +320,7 @@
                      muonrate.Data(), PSF.Data(),
                      datarate, maxhum.Data(),
-                     numstarsmean.Data(), numstarsrms.Data(),
-                     skybrightnessmean.Data(), skybrightnessrms.Data(),
+                     numstarsmed.Data(), numstarsrms.Data(),
+                     numcorsmed.Data(), numcorsrms.Data(),
+                     skybrightnessmed.Data(), skybrightnessrms.Data(),
                      inhomogen.Data(), seq);
     }
Index: trunk/MagicSoft/Mars/datacenter/macros/plotdb.C
===================================================================
--- trunk/MagicSoft/Mars/datacenter/macros/plotdb.C	(revision 7703)
+++ trunk/MagicSoft/Mars/datacenter/macros/plotdb.C	(revision 7756)
@@ -449,7 +449,11 @@
 
     plot.SetDescription("Median No. Stars recognized by the starguider;N", "StarsMed");
-    plot.Plot("Star.fNumStarsMean",             0,  70, 1);
+    plot.Plot("Star.fNumStarsMed",              0,  70, 1);
     plot.SetDescription("RMS No. Stars recognized by the starguider;\\sigma_{N}", "StarsRMS");
     plot.Plot("Star.fNumStarsRMS",              0,  25, 1);
+    plot.SetDescription("Median No. Stars correlated by the starguider;N", "StarsMed");
+    plot.Plot("Star.fNumCorMed",                0,  70, 1);
+    plot.SetDescription("RMS No. Stars correlated by the starguider;\\sigma_{N}", "StarsRMS");
+    plot.Plot("Star.fNumCorRMS",                0,  25, 1);
     plot.SetDescription("Median skbrightess measured by the starguider;B [au]", "BrightMed");
     plot.Plot("Star.fBrightnessMean",           0, 111, 1);